<?php
/*                                                                                                                                                       
  mememe                                     ememem
    \ememememem                       ememememem/ 
     ememememememem               ememememememem  
      emememememememe           emememememememe   
         \memememememem       ememememememe/      
         emememememememe     emememememememe     
                 emememem   ememememe              
                     ememe ememe                   
                       emememe                     
                         eme
                          e 

	^^ Title : Ban IP Funny						 
	^^ Create : 2018-02-09
	^^ For PS version 1.4, 1.5, 1.6, 1.7
	   @author : EAGLEMEDIA.de <eagle@eaglemedia.de>
	   @copyright : EAGLEMEDIA.de	   
	   @license : See appended file license.txt
	   @link : http://eaglemedia.de 
*/

	# Reports for either E_ERROR | E_WARNING | 
	# E_NOTICE | Any Error
	#
	#ini_set("display_startup_errors", 1);
	#ini_set("display_errors", 1);
	#error_reporting(E_ALL);

if (!defined('_PS_VERSION_')) 
	exit;

class banIpFunny extends Module 
{	
	public function __construct()
	{
		$this->name = 'banipfunny';
		$this->tab = 'administration';        
		$this->version = '1.4.2';
		$this->author = 'EAGLEMEDIA.de';		
		
		$this->bootstrap = true;
		parent::__construct();
		
		$this->displayName = $this->l('Ban Ip Funny');
		$this->description = $this->l('Ban unwanted users, block any ip address, hosting name, internet organisation, web proxies you want. Secure your shop!');
		$this->ps_versions_compliancy = array('min' => '1.4', 'max' => _PS_VERSION_);		
		
		$this->confirmUninstall = $this->l('Are you sure you want to delete these details?');			
	}	
        
	public function install()
	{
		/*   Private network or proxy list .
		 *   See : https://en.wikipedia.org/wiki/Private_network
		 */ 
		$ipSpansProxies = '10.0.0.0 - 10.255.255.255, 172.16.0.0 - 172.31.255.255, 192.168.0.0 - 192.168.255.255';
	        
		if ( !parent::install()
		  OR !$this->registerHook('header')
		  OR !$this->registerHook('backOfficeHeader')
		  OR !Configuration::updateValue('BANIP_BLOCK_1', '')	
          OR !Configuration::updateValue('BANIP_BLOCK_MSG_1', 'Oops , you were blocked !')
		  OR !Configuration::updateValue('BANIP_BLOCK_2', '')
		  OR !Configuration::updateValue('BANIP_BLOCK_MSG_2', 'Hmm , i think you\'re a idiot !')
		  OR !Configuration::updateValue('BANIP_BLOCK_3', $ipSpansProxies)
		  OR !Configuration::updateValue('BANIP_BLOCK_MSG_3', 'Unfortunately , proxies are not allowed ...')
		  OR !Configuration::updateValue('BANIP_CHECK_3', '1')
		  OR !Configuration::updateValue('BANIP_BLOCK_4', '')	
          OR !Configuration::updateValue('BANIP_BLOCK_MSG_4', 'Oops , you were blocked !')		  
		  OR !Configuration::updateValue('BANIP_BLOCK_MSG_5', 'Unfortunately , WebProxy and TorNetwork are not allowed ...')
          OR !Configuration::updateValue('BANIP_CHECK_5', '')
		  OR !Configuration::updateValue('BANIP_BLOCK_6', '')	
          OR !Configuration::updateValue('BANIP_BLOCK_MSG_6', 'Unfortunately , this organization is not allowed ...') )
            return false;
        return true;
	}
	
	public function uninstall()
	{
	 	if ( !parent::uninstall() 
	  	  OR !Configuration::deleteByName('BANIP_BLOCK_1')   
		  OR !Configuration::deleteByName('BANIP_BLOCK_MSG_1') 
		  OR !Configuration::deleteByName('BANIP_BLOCK_2')   
		  OR !Configuration::deleteByName('BANIP_BLOCK_MSG_2')
	   	  OR !Configuration::deleteByName('BANIP_BLOCK_3')   
		  OR !Configuration::deleteByName('BANIP_BLOCK_MSG_3')
		  OR !Configuration::deleteByName('BANIP_CHECK_3')
		  OR !Configuration::deleteByName('BANIP_BLOCK_4')	
          OR !Configuration::deleteByName('BANIP_BLOCK_MSG_4')		  	
          OR !Configuration::deleteByName('BANIP_BLOCK_MSG_5')
		  OR !Configuration::deleteByName('BANIP_CHECK_5')
		  OR !Configuration::deleteByName('BANIP_BLOCK_6')	
          OR !Configuration::deleteByName('BANIP_BLOCK_MSG_6')		  )
	 		return false;
	 	return true;
	}

	public function postProcess()
	{
		/*  Only pro version ....
		 */
		$ipCheck5 = Tools::getValue('BANIP_CHECK_5_');
		$ipCheck5 = '';
		
		
		if (  Tools::isSubmit('banip_cross')
		  AND Configuration::updateValue('BANIP_BLOCK_1', Tools::getValue('BANIP_BLOCK_1'))
		  AND Configuration::updateValue('BANIP_BLOCK_MSG_1', Tools::getValue('BANIP_BLOCK_MSG_1'))
		  AND Configuration::updateValue('BANIP_BLOCK_2', Tools::getValue('BANIP_BLOCK_2'))
		  AND Configuration::updateValue('BANIP_BLOCK_MSG_2', Tools::getValue('BANIP_BLOCK_MSG_2'))
		  AND Configuration::updateValue('BANIP_BLOCK_MSG_3', Tools::getValue('BANIP_BLOCK_MSG_3'))
		  AND Configuration::updateValue('BANIP_CHECK_3', Tools::getValue('BANIP_CHECK_3'))
		      AND Configuration::updateValue('BANIP_CHECK_3', Tools::getValue('BANIP_CHECK_3_'))
		  AND Configuration::updateValue('BANIP_BLOCK_4', Tools::getValue('BANIP_BLOCK_4'))
		  AND Configuration::updateValue('BANIP_BLOCK_MSG_4', Tools::getValue('BANIP_BLOCK_MSG_4'))
		      AND Configuration::updateValue('BANIP_CHECK_5', $ipCheck5)
		  AND Configuration::updateValue('BANIP_BLOCK_6', Tools::getValue('BANIP_BLOCK_6'))
		  AND Configuration::updateValue('BANIP_BLOCK_MSG_6', Tools::getValue('BANIP_BLOCK_MSG_6'))  )
            return $this->displayConfirmation($this->l('The settings have been updated.'));
	}
	
	public function getContent()
	{
		if ( ip2long(_PS_VERSION_) >= ip2long('1.4.0.0') 
		 AND ip2long(_PS_VERSION_)  < ip2long('1.5.0.0') )
		    $content = $this->postProcess().$this->renderForm4();
					
		if ( ip2long(_PS_VERSION_) >= ip2long('1.5.0.0') )
		    $content = $this->postProcess().$this->renderForm5();
			
		return $content;
	}

	public function renderForm4()
	{
	    $fields_form = '
		<h2>'.$this->displayName.'</h2>
		<form action="'.$_SERVER['REQUEST_URI'].'" method="post">
            <fieldset><legend><img src="'.$this->_path.'logo.png" alt="" title="" />'.$this->l('Settings').'</legend>
                <label>'.$this->l('Ip address block , 1').'</label>
                <div class="margin-form">
                    <textarea name="BANIP_BLOCK_1" class="banip_"/>'.Configuration::get('BANIP_BLOCK_1').'</textarea>
					<span>'.$this->l('Write this form : 0.0.0.0, 9.9.9.9, ...').'</span>
                </div> 
                <label>'.$this->l('Message , 1').'</label>
                <div class="margin-form">
                    <textarea name="BANIP_BLOCK_MSG_1" class="banip_"/>'.Configuration::get('BANIP_BLOCK_MSG_1').'</textarea>
                </div>
				
				    <p><br /><br /></p>		
						
				<label>'.$this->l('Ip address block , 2').'</label>
                <div class="margin-form">
                    <textarea name="BANIP_BLOCK_2" class="banip_"/>'.Configuration::get('BANIP_BLOCK_2').'</textarea>
					<span>'.$this->l('Write this form : 0.0.0.0, 9.9.9.9, ...').'</span>
                </div>
                <label>'.$this->l('Message , 2').'</label>
                <div class="margin-form">
                    <textarea name="BANIP_BLOCK_MSG_2" class="banip_"/>'.Configuration::get('BANIP_BLOCK_MSG_2').'</textarea>					
                </div>				
				
				    <p><br /><br /></p>
				
				<label>'.$this->l('Ip address range , proxies').'</label>
                <div class="margin-form">
                    <textarea name="BANIP_BLOCK_3" class="banip_ readonly"/>'.Configuration::get('BANIP_BLOCK_3').'</textarea>
					<span>'.$this->l('Spans , only this form : 0.0.0.0 - 0.0.0.9, 13.0.0.0 - 13.0.0.9, ...').'</span>
                </div>
                <label>'.$this->l('Message , proxies').'</label>
                <div class="margin-form">
                    <textarea name="BANIP_BLOCK_MSG_3" class="banip_"/>'.Configuration::get('BANIP_BLOCK_MSG_3').'</textarea>					
                </div>
                <div class="margin-form">
                    <input type="checkbox" name="BANIP_CHECK_3" value="'.Configuration::get('BANIP_CHECK_3').'"/>
					<span>'.$this->l('Prevent view via proxies ?').'</span>
                </div>			

				    <p><br /><br /></p>	
				
                <label>'.$this->l('Names , hosts').'</label>
                <div class="margin-form">
                    <textarea name="BANIP_BLOCK_4" class="banip_"/>'.Configuration::get('BANIP_BLOCK_4').'</textarea>
					<span>'.$this->l('Write this form : telecom.us, telekom.de, ...').'</span>
                </div> 
                <label>'.$this->l('Message , hosts').'</label>
                <div class="margin-form">
                    <textarea name="BANIP_BLOCK_MSG_4" class="banip_"/>'.Configuration::get('BANIP_BLOCK_MSG_4').'</textarea>
                </div>
				
				    <p><br /><br /></p>				
				
                <label>'.$this->l('Names , organization').'</label>
                <div class="margin-form">
                    <textarea name="BANIP_BLOCK_6" class="banip_"/>'.Configuration::get('BANIP_BLOCK_6').'</textarea>
					<span>'.$this->l('Write this form : Turkish Network Ltd, Petersburg Internet Network ltd., ...').'</span>
                </div> 
                <label>'.$this->l('Message , organizations').'</label>
                <div class="margin-form">
                    <textarea name="BANIP_BLOCK_MSG_6" class="banip_"/>'.Configuration::get('BANIP_BLOCK_MSG_6').'</textarea>
                </div>
				
				    <p><br /><br /></p>	
				
                <label>'.$this->l('Message , WebProxys and Tor').'</label>
                <div class="margin-form">
                    <textarea name="BANIP_BLOCK_MSG_5" class="banip_"/>'.Configuration::get('BANIP_BLOCK_MSG_5').'</textarea>					
                </div>
                <div class="margin-form">
                    <input type="checkbox" name="BANIP_CHECK_5" value="'.Configuration::get('BANIP_CHECK_5').'"/>
					<span>'.$this->l('Prevent view via WebProxys, Tor ? This function is a external Services by https://db-ip.com/. :::: Only for \'Ban Ip FunnyPro\'').'</span>
                </div>	
							
				    <p><br /><br /></p>					
								            
                <div style="margin-top:20px; text-align:center">
	               <input type="submit" name="banip_cross" class="button" value="'.$this->l('Update').'">
	            </div>          
            </fieldset>
		</form>       
        ';	
		
		return $fields_form;
	}

	public function renderForm5()
	{
		$fields_form = array(
			'form' => array(
				'legend' => array(
					'title' => $this->l('Settings'),
					'icon' => 'icon-cogs'
				),
				'input' => array(
					array(
						'type' => 'textarea',				
						'label' => $this->l('Ip address block , 1'),
						'name' => 'BANIP_BLOCK_1',
						'class' => 'banip_',
						'desc' => $this->l('Write this form : 0.0.0.0, 9.9.9.9, ...')
					),
					array(
						'type' => 'textarea',
						'label' => $this->l('Message , 1'),
						'name' => 'BANIP_BLOCK_MSG_1',
						'class' => 'banip_'
					),					
					array(
						'type' => 'textarea',				
						'label' => $this->l('Ip address block , 2'),
						'name' => 'BANIP_BLOCK_2',
						'class' => 'banip_',
						'desc' => $this->l('Write this form : 0.0.0.0, 9.9.9.9, ...')
					),					
					array(
						'type' => 'textarea',
						'label' => $this->l('Message , 2'),
						'name' => 'BANIP_BLOCK_MSG_2'
					),
					array(
						'type' => 'textarea',				
						'label' => $this->l('Ip address range , proxies'),
						'name' => 'BANIP_BLOCK_3',
						'class' => '',
						'desc' => $this->l('Spans , only this form : 0.0.0.0 - 0.0.0.9, 13.0.0.0 - 13.0.0.9, ...')
					),					
					array(
						'type' => 'textarea',
						'label' => $this->l('Message , proxies'),
						'name' => 'BANIP_BLOCK_MSG_3'						
					),
					array(
						'type' => 'checkbox',						
						'name' => 'BANIP_CHECK_3',
						'values' => array(
							'query' => 1
						),
						'desc' => $this->l('Prevent view via proxies ?')
					),					
					array(
						'type' => 'textarea',				
						'label' => $this->l('Names , hosts'),
						'name' => 'BANIP_BLOCK_4',
						'class' => 'banip_',
						'desc' => $this->l('Write this form : telecom.us, telekom.de, ...')
					),
					array(
						'type' => 'textarea',
						'label' => $this->l('Message , hosts'),
						'name' => 'BANIP_BLOCK_MSG_4',
						'class' => 'banip_'
					),
					array(
						'type' => 'textarea',				
						'label' => $this->l('Names , organization'),
						'name' => 'BANIP_BLOCK_6',
						'class' => 'banip_',
						'desc' => $this->l('Write this form : Turkish Network Ltd, Petersburg Internet Network ltd., ...')
					),
					array(
						'type' => 'textarea',
						'label' => $this->l('Message , organizations'),
						'name' => 'BANIP_BLOCK_MSG_6',
						'class' => 'banip_'
					),
					array(
						'type' => 'textarea',
						'label' => $this->l('Message , WebProxys, Tor'),
						'name' => 'BANIP_BLOCK_MSG_5'						
					),
					array(
						'type' => 'checkbox',						
						'name' => 'BANIP_CHECK_5',
						'values' => array(
							'query' => 1
						),
						'desc' => $this->l('Prevent view via WebProxys, Tor ? This function is a external Services by https://db-ip.com/. :::: Only for \'Ban Ip FunnyPro\'')
					),
				),
				'submit' => array(
					'title' => $this->l('Update')
				)
			)
		);

		$helper = new HelperForm();
		$helper->show_toolbar = false;
		$helper->table =  $this->table;
		$lang = new Language((int)Configuration::get('PS_LANG_DEFAULT'));
		$helper->default_form_language = $lang->id;
		$helper->module = $this;
		$helper->allow_employee_form_lang = Configuration::get('PS_BO_ALLOW_EMPLOYEE_FORM_LANG') ? Configuration::get('PS_BO_ALLOW_EMPLOYEE_FORM_LANG') : 0;
		$helper->identifier = $this->identifier;
		$helper->submit_action = 'banip_cross';
		$helper->currentIndex = $this->context->link->getAdminLink('AdminModules', false).'&configure='.$this->name.'&tab_module='.$this->tab.'&module_name='.$this->name;
		$helper->token = Tools::getAdminTokenLite('AdminModules');
		$helper->tpl_vars = array(
			'uri' => $this->getPathUri(),
			'fields_value' => $this->getConfigFieldsValues(),
			'languages' => $this->context->controller->getLanguages(),
			'id_language' => $this->context->language->id
		);

		return $helper->generateForm(array($fields_form));
	}	

	public function getConfigFieldsValues()
	{
		
		$fields = array(		
			'BANIP_BLOCK_1' => Tools::getValue('BANIP_BLOCK_1', Configuration::get('BANIP_BLOCK_1')),     
            'BANIP_BLOCK_MSG_1' => Tools::getValue('BANIP_BLOCK_MSG_1', Configuration::get('BANIP_BLOCK_MSG_1')),			
			'BANIP_BLOCK_2' => Tools::getValue('BANIP_BLOCK_2', Configuration::get('BANIP_BLOCK_2')),
            'BANIP_BLOCK_MSG_2' => Tools::getValue('BANIP_BLOCK_MSG_2', Configuration::get('BANIP_BLOCK_MSG_2')),			
            'BANIP_BLOCK_3' => Tools::getValue('BANIP_BLOCK_3', Configuration::get('BANIP_BLOCK_3')),
			'BANIP_BLOCK_MSG_3' => Tools::getValue('BANIP_BLOCK_MSG_3', Configuration::get('BANIP_BLOCK_MSG_3')),
			'BANIP_CHECK_3_' => Tools::getValue('BANIP_CHECK_3_', Configuration::get('BANIP_CHECK_3')),
			'BANIP_BLOCK_4' => Tools::getValue('BANIP_BLOCK_4', Configuration::get('BANIP_BLOCK_4')),     
            'BANIP_BLOCK_MSG_4' => Tools::getValue('BANIP_BLOCK_MSG_4', Configuration::get('BANIP_BLOCK_MSG_4')),
			'BANIP_BLOCK_MSG_5' => Tools::getValue('BANIP_BLOCK_MSG_5', Configuration::get('BANIP_BLOCK_MSG_5')),
			'BANIP_CHECK_5_' => Tools::getValue('BANIP_CHECK_5_', Configuration::get('BANIP_CHECK_5')),
			'BANIP_BLOCK_6' => Tools::getValue('BANIP_BLOCK_6', Configuration::get('BANIP_BLOCK_6')),     
            'BANIP_BLOCK_MSG_6' => Tools::getValue('BANIP_BLOCK_MSG_6', Configuration::get('BANIP_BLOCK_MSG_6'))
		);

		return $fields;
	} 
			
	public function hookBackOfficeHeader()
	{    

		if ( ip2long(_PS_VERSION_) >= ip2long('1.4.0.0') 
		 AND ip2long(_PS_VERSION_)  < ip2long('1.7.0.0') )
		{
			$cssJS  = '
		<link type="text/css" rel="stylesheet" href="'.($this->_path.'css/banipfunny.css').'" />
		<script type="text/javascript" src="'.($this->_path.'js/banipfunny.js').'"></script>
			';
			
			return $cssJS;
		}
		
		if ( ip2long(_PS_VERSION_) >= ip2long('1.7.0.0') )
		{
	        $this->context->controller->addCSS($this->_path.'css/banipfunny.css', 'all');
			$this->context->controller->addJS($this->_path.'js/banipfunny.js', 'all');
		}
	}		

    public function hookHeader( $params )
	{
	    $spec = $this->checkSpecificIpAdresses();		
        if ( $spec == 1 ) 
            die('<h1 style="font-family:Verdana; text-align:center; margin:3em;">'.Configuration::get('BANIP_BLOCK_MSG_1').'</h1>');
        else if ( $spec == 2 )
            die('<h1 style="font-family:Verdana; text-align:center; margin:3em;">'.Configuration::get('BANIP_BLOCK_MSG_2').'</h1>');			
        else if ( $spec == 3 )
			die('<h1 style="font-family:Verdana; text-align:center; margin:3em;">'.Configuration::get('BANIP_BLOCK_MSG_3').'</h1>');    
			
		 
		$this->checkHostName();
		$this->checkOrganization();

			
		if ( Configuration::get('BANIP_CHECK_5') == 'on' )			
		  if ( $this->boolBadConnections() !== false )
		     die('<h1 style="font-family:Verdana; text-align:center; margin:3em;">'.Configuration::get('BANIP_BLOCK_MSG_5').'</h1>');		 
		
		
	} 
	
	#
	#
	#
	#	
	public function getCustomerIp() 
	{
	    $ip = array();
		
		if (!empty($_SERVER['HTTP_CLIENT_IP']))
			$ip[] = $_SERVER['HTTP_CLIENT_IP'];
		elseif (!empty($_SERVER['HTTP_X_FORWARDED_FOR']))
			$ip[] = $_SERVER['HTTP_X_FORWARDED_FOR'];
		else
			$ip[] = $_SERVER['REMOTE_ADDR'];

        if(!empty($ip[0]) && strlen($ip[0]) > 7)
		    $ip = $ip[0];
        if(!empty($ip[1]) && strlen($ip[1]) > 7)
		    $ip = $ip[1];
        if(!empty($ip[2]) && strlen($ip[2]) > 7)
		    $ip = $ip[2];			
       
		return $ip;
	}
	
   /*  Check manual ip addesses
    *  
	*/
	public function checkSpecificIpAdresses() 
	{  
		$ip = $this->getCustomerIp(); 

		if( $ip )
		{
            
            if ( $banIpBlock1 = trim(Configuration::get('BANIP_BLOCK_1')) ) 
            { 
                $arrDenyIp1 = explode( ',', str_replace(' ', '', $banIpBlock1));                
                foreach( $arrDenyIp1 as $denyIp1 ) 
                {                
                    if ( preg_match('/'.$denyIp1.'/', $ip) )
                        return 1;
                }			    
            }
            
            if ( $banIpBlock2 = trim(Configuration::get('BANIP_BLOCK_2')) ) 
            {                               
                $arrDenyIp2 = explode( ',', str_replace(' ', '', $banIpBlock2));
                foreach( $arrDenyIp2 as $denyIp2 ) 
                {                
                    if ( preg_match('/'.$denyIp2.'/', $ip) )
                        return 2;
                }                
            }
				
			if ( $banIpBlock3 = Configuration::get('BANIP_BLOCK_3') )
			{
				$pos = strrpos($banIpBlock3, ',', -1);
				if ($pos !== false)
					$cleanBanIpBlock3 = rtrim($banIpBlock3,',');
					
				$arrSpansProxies = explode( ',', str_replace(' ', '', $cleanBanIpBlock3) );
				$userIp2long = ip2long($ip);
				$proxy_ = array();
				foreach( $arrSpansProxies as $spansProxies )
				{
					$arrProxy = explode('-', $spansProxies);
					foreach( $arrProxy as $proxy )
					{				
						$proxy_[] = ip2long($proxy);			
					}			
				}	
			
				if ( $userIp2long >= $proxy_[0] AND $userIp2long <= $proxy_[1] 
				  OR $userIp2long >= $proxy_[2] AND $userIp2long <= $proxy_[3]
				  OR $userIp2long >= $proxy_[4] AND $userIp2long <= $proxy_[5] )
					return 3;
				
			}		
		}
		
		return false;
	}
	
   /*  Check host name
    *  
	*/
	public function checkHostName() 
	{  
		$ip = $this->getCustomerIp(); 

		if( $ip )
		{
			if( str_replace(' ', '', Configuration::get('BANIP_BLOCK_4')) )
			{
				$userHost = @gethostbyaddr($ip);
				$banIpBlock4 = Configuration::get('BANIP_BLOCK_4');
				$pos = strrpos($banIpBlock4, ',', -1);
				if ($pos !== false)
					$banIpBlock4 = rtrim($banIpBlock4,',');
	
				$arrDenyHosts = explode( ',', str_replace(' ', '', $banIpBlock4));	   
				foreach ( $arrDenyHosts as $denyHost )
					if ( strpos( $userHost, $denyHost ) !== false )
						die('<h1 style="font-family:Verdana; text-align:center; margin:3em;">'.Configuration::get('BANIP_BLOCK_MSG_4').'</h1>');
			}		
		}
	}
	
   /*  Check Organization
    *  External Services
	*/
	public function checkOrganization() 
	{  
		$ip = $this->getCustomerIp(); 
     
		if( $ip )
		{
			if( str_replace(' ', '', Configuration::get('BANIP_BLOCK_6')) )
			{	
				$html = file_get_contents('https://db-ip.com/'.$ip);
				#echo $html;
				preg_match_all('/<th>(.*?)<\/th><td>(.*?)<\/td>/s', $html, $output, PREG_SET_ORDER);
				$coll[] = $output[1][1].': '.$output[1][2];
				$coll[] = $output[2][1].': '.$output[2][2];
				$coll[] = $output[3][1].': '.$output[3][2];
				$coll[] = $output[4][1].': '.$output[4][2];
				$coll[] = $output[5][1].': '.$output[5][2];
				$coll[] = $output[6][1].': '.$output[6][2];
				$coll[] = $output[7][1].': '.$output[7][2];
				$coll[] = $output[8][1].': '.$output[8][2];
				$coll[] = $output[9][1].': '.$output[9][2];
				$coll[] = $output[10][1].': '.$output[10][2];
				$coll[] = $output[11][1].': '.$output[11][2];
				$coll[] = $output[12][1].': '.$output[12][2];
				$coll[] = $output[13][1].': '.$output[13][2];
				$coll[] = $output[14][1].': '.$output[14][2];
				$coll[] = $output[15][1].': '.$output[15][2];
				$coll[] = $output[16][1].': '.$output[16][2];
				$coll[] = $output[17][1].': '.$output[17][2];
				$coll[] = $output[18][1].': '.$output[18][2];
				$coll[] = $output[19][1].': '.$output[19][2];

				$banIpBlock6 = Configuration::get('BANIP_BLOCK_6');
				$pos = strrpos($banIpBlock6, ',', -1);
				if ($pos !== false)
					$banIpBlock6 = rtrim($banIpBlock6,',');
	
				$arrDenyOrg = explode( ',', str_replace(' ', '', $banIpBlock6));
				
				foreach( $coll as $item )			   
					if( substr($item, 0, 12) =='Organization' )
						if ( in_array(str_replace(' ', '', substr($item, 13)) , $arrDenyOrg ) !== false )
							die('<h1 style="font-family:Verdana; text-align:center; margin:3em;">'.Configuration::get('BANIP_BLOCK_MSG_6').'</h1>');
			}
		}	
	}	
    
   /*  Check WebProxy, Tor
    *  External Services
	*/
	public function boolBadConnections() 
	{  
		$ip = $this->getCustomerIp(); 
     
		if( $ip )
		{		
			$html = file_get_contents('https://db-ip.com/'.$ip);
			#echo $html;
			preg_match_all('/<th>(.*?)<\/th><td>(.*?)<\/td>/s', $html, $output, PREG_SET_ORDER);
			$coll[] = $output[1][1].': '.$output[1][2];
			$coll[] = $output[2][1].': '.$output[2][2];
			$coll[] = $output[3][1].': '.$output[3][2];
			$coll[] = $output[4][1].': '.$output[4][2];
			$coll[] = $output[5][1].': '.$output[5][2];
			$coll[] = $output[6][1].': '.$output[6][2];
			$coll[] = $output[7][1].': '.$output[7][2];
			$coll[] = $output[8][1].': '.$output[8][2];
			$coll[] = $output[9][1].': '.$output[9][2];
			$coll[] = $output[10][1].': '.$output[10][2];
			$coll[] = $output[11][1].': '.$output[11][2];
			$coll[] = $output[12][1].': '.$output[12][2];
			$coll[] = $output[13][1].': '.$output[13][2];
			$coll[] = $output[14][1].': '.$output[14][2];
			$coll[] = $output[15][1].': '.$output[15][2];
			$coll[] = $output[16][1].': '.$output[16][2];
			$coll[] = $output[17][1].': '.$output[17][2];
			$coll[] = $output[18][1].': '.$output[18][2];
			$coll[] = $output[19][1].': '.$output[19][2];

			foreach( $coll as $item )	
				if( substr(preg_replace( '/[^[:print:]]/', '', str_replace('	', '', str_replace('&nbsp;', '', strip_tags($item)))), 0, 10) == 'Proxy: Yes')
					return true;
		}		

		return false;
	}	
}	
